head	1.2;
access;
symbols;
locks;
comment	@ * @;


1.2
date	2006.05.26.15.59.50;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2006.05.19.16.10.58;	author Average;	state Exp;
branches;
next	;


desc
@@


1.2
log
@ƃC^[tF[Xς܂
@
text
@{******************************************************************************}
{* DCPcrypt v2.0 written by David Barton (crypto@@cityinthesky.co.uk) **********}
{******************************************************************************}
{* Block cipher component definitions *****************************************}
{******************************************************************************}
{* Copyright (c) 1999-2002 David Barton                                       *}
{* Permission is hereby granted, free of charge, to any person obtaining a    *}
{* copy of this software and associated documentation files (the "Software"), *}
{* to deal in the Software without restriction, including without limitation  *}
{* the rights to use, copy, modify, merge, publish, distribute, sublicense,   *}
{* and/or sell copies of the Software, and to permit persons to whom the      *}
{* Software is furnished to do so, subject to the following conditions:       *}
{*                                                                            *}
{* The above copyright notice and this permission notice shall be included in *}
{* all copies or substantial portions of the Software.                        *}
{*                                                                            *}
{* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR *}
{* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,   *}
{* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    *}
{* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER *}
{* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING    *}
{* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER        *}
{* DEALINGS IN THE SOFTWARE.                                                  *}
{******************************************************************************}
UNIT ciphers;

INTERFACE
USES
  Classes, Sysutils, crypt2;

{******************************************************************************}
    { Base type definition for 64 bit block ciphers }
TYPE
  TDCP_blockcipher64= CLASS(TDCP_blockcipher)
  PRIVATE
    IV, CV: ARRAY[0..7] OF BYTE;

    PROCEDURE IncCounter;
  PUBLIC
    CLASS FUNCTION GetBlockSize: INTEGER; override;
      { Get the block size of the cipher (in bits) }

    PROCEDURE Reset; override;
      { Reset any stored chaining information }
    PROCEDURE Burn; override;
      { Clear all stored key information and chaining information }
    PROCEDURE SetIV(CONST Value); override;
      { Sets the IV to Value and performs a reset }
    PROCEDURE GetIV(VAR Value); override;
      { Returns the current chaining information, not the actual IV }
    PROCEDURE Init(CONST Key; Size: longword; InitVector: POINTER); override;
      { Do key setup based on the data in Key, size is in bits }

    PROCEDURE EncryptCBC(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CBC method of encryption }
    PROCEDURE DecryptCBC(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CBC method of decryption }
    PROCEDURE EncryptCFB8bit(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CFB (8 bit) method of encryption }
    PROCEDURE DecryptCFB8bit(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CFB (8 bit) method of decryption }
    PROCEDURE EncryptCFBblock(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CFB (block) method of encryption }
    PROCEDURE DecryptCFBblock(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CFB (block) method of decryption }
    PROCEDURE EncryptOFB(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt
      size bytes of data using the OFB method of encryption }
    PROCEDURE DecryptOFB(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the OFB method of decryption }
    PROCEDURE EncryptCTR(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CTR method of encryption }
    PROCEDURE DecryptCTR(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CTR method of decryption }
  END;

{******************************************************************************}
    { Base type definition for 128 bit block ciphers }
TYPE
  TDCP_blockcipher128= CLASS(TDCP_blockcipher)
  PRIVATE
    IV, CV: ARRAY[0..15] OF BYTE;

    PROCEDURE IncCounter;
  PUBLIC
    CLASS FUNCTION GetBlockSize: INTEGER; override;
      { Get the block size of the cipher (in bits) }

    PROCEDURE Reset; override;
      { Reset any stored chaining information }
    PROCEDURE Burn; override;
      { Clear all stored key information and chaining information }
    PROCEDURE SetIV(CONST Value); override;
      { Sets the IV to Value and performs a reset }
    PROCEDURE GetIV(VAR Value); override;
      { Returns the current chaining information, not the actual IV }
    PROCEDURE Init(CONST Key; Size: longword; InitVector: POINTER); override;
      { Do key setup based on the data in Key, size is in bits }

    PROCEDURE EncryptCBC(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CBC method of encryption }
    PROCEDURE DecryptCBC(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CBC method of decryption }
    PROCEDURE EncryptCFB8bit(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CFB (8 bit) method of encryption }
    PROCEDURE DecryptCFB8bit(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CFB (8 bit) method of decryption }
    PROCEDURE EncryptCFBblock(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CFB (block) method of encryption }
    PROCEDURE DecryptCFBblock(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CFB (block) method of decryption }
    PROCEDURE EncryptOFB(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the OFB method of encryption }
    PROCEDURE DecryptOFB(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the OFB method of decryption }
    PROCEDURE EncryptCTR(CONST Indata; VAR Outdata; Size: longword); override;
      { Encrypt size bytes of data using the CTR method of encryption }
    PROCEDURE DecryptCTR(CONST Indata; VAR Outdata; Size: longword); override;
      { Decrypt size bytes of data using the CTR method of decryption }
  END;

IMPLEMENTATION


{** TDCP_blockcipher64 ********************************************************}

PROCEDURE TDCP_blockcipher64.IncCounter;
VAR
  i: INTEGER;
BEGIN
  Inc(CV[7]);
  i:= 7;
  WHILE (i> 0) AND (CV[i] = 0) DO
  BEGIN
    Inc(CV[i-1]);
    Dec(i);
  END;
END;

CLASS FUNCTION TDCP_blockcipher64.GetBlockSize: INTEGER;
BEGIN
  Result:= 64;
END;

PROCEDURE TDCP_blockcipher64.Init(CONST Key; Size: longword; InitVector: POINTER);
BEGIN
  inherited Init(Key,Size,InitVector);
  InitKey(Key,Size);
  IF InitVector= NIL THEN
  BEGIN
    FillChar(IV,8,{$IFDEF DCP1COMPAT}$FF{$ELSE}0{$ENDIF});
    EncryptECB(IV,IV);
    Reset;
  END
  ELSE
  BEGIN
    Move(InitVector^,IV,8);
    Reset;
  END;
END;

PROCEDURE TDCP_blockcipher64.SetIV(CONST Value);
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  Move(Value,IV,8);
  Reset;
END;

PROCEDURE TDCP_blockcipher64.GetIV(VAR Value);
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  Move(CV,Value,8);
END;

PROCEDURE TDCP_blockcipher64.Reset;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized')
  ELSE
    Move(IV,CV,8);
END;

PROCEDURE TDCP_blockcipher64.Burn;
BEGIN
  FillChar(IV,8,$FF);
  FillChar(CV,8,$FF);
  inherited Burn;
END;

PROCEDURE TDCP_blockcipher64.EncryptCBC(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    Move(p1^,p2^,8);
    XorBlock(p2^,CV,8);
    EncryptECB(p2^,p2^);
    Move(p2^,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.DecryptCBC(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
  Temp: ARRAY[0..7] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    Move(p1^,p2^,8);
    Move(p1^,Temp,8);
    DecryptECB(p2^,p2^);
    XorBlock(p2^,CV,8);
    Move(Temp,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.EncryptCFB8bit(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  Temp: ARRAY[0..7] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO Size DO
  BEGIN
    EncryptECB(CV,Temp);
    p2^:= p1^ xor Temp[0];
    Move(CV[1],CV[0],8-1);
    CV[7]:= p2^;
    Inc(p1);
    Inc(p2);
  END;
END;

PROCEDURE TDCP_blockcipher64.DecryptCFB8bit(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  TempByte: BYTE;
  Temp: ARRAY[0..7] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO Size DO
  BEGIN
    TempByte:= p1^;
    EncryptECB(CV,Temp);
    p2^:= p1^ xor Temp[0];
    Move(CV[1],CV[0],8-1);
    CV[7]:= TempByte;
    Inc(p1);
    Inc(p2);
  END;
END;

PROCEDURE TDCP_blockcipher64.EncryptCFBblock(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,8);
    XorBlock(p2^,CV,8);
    Move(p2^,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.DecryptCFBblock(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  Temp: ARRAY[0..7] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    Move(p1^,Temp,8);
    EncryptECB(CV,CV);
    Move(p1^,p2^,8);
    XorBlock(p2^,CV,8);
    Move(Temp,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.EncryptOFB(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,8);
    XorBlock(p2^,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.DecryptOFB(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,8);
    XorBlock(p2^,CV,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,CV,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.EncryptCTR(CONST Indata; VAR Outdata; Size: longword);
VAR
  temp: ARRAY[0..7] OF BYTE;
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,8);
    XorBlock(p2^,temp,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,temp,Size mod 8);
  END;
END;

PROCEDURE TDCP_blockcipher64.DecryptCTR(CONST Indata; VAR Outdata; Size: longword);
VAR
  temp: ARRAY[0..7] OF BYTE;
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 8) DO
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,8);
    XorBlock(p2^,temp,8);
    p1:= POINTER(longword(p1) + 8);
    p2:= POINTER(longword(p2) + 8);
  END;
  IF (Size mod 8)<> 0 THEN
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,Size mod 8);
    XorBlock(p2^,temp,Size mod 8);
  END;
END;

{** TDCP_blockcipher128 ********************************************************}

PROCEDURE TDCP_blockcipher128.IncCounter;
VAR
  i: INTEGER;
BEGIN
  Inc(CV[15]);
  i:= 15;
  WHILE (i> 0) AND (CV[i] = 0) DO
  BEGIN
    Inc(CV[i-1]);
    Dec(i);
  END;
END;

CLASS FUNCTION TDCP_blockcipher128.GetBlockSize: INTEGER;
BEGIN
  Result:= 128;
END;

PROCEDURE TDCP_blockcipher128.Init(CONST Key; Size: longword; InitVector: POINTER);
BEGIN
  inherited Init(Key,Size,InitVector);
  InitKey(Key,Size);
  IF InitVector= NIL THEN
  BEGIN
    FillChar(IV,16,{$IFDEF DCP1COMPAT}$FF{$ELSE}0{$ENDIF});
    EncryptECB(IV,IV);
    Reset;
  END
  ELSE
  BEGIN
    Move(InitVector^,IV,16);
    Reset;
  END;
END;

PROCEDURE TDCP_blockcipher128.SetIV(CONST Value);
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  Move(Value,IV,16);
  Reset;
END;

PROCEDURE TDCP_blockcipher128.GetIV(VAR Value);
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  Move(CV,Value,16);
END;

PROCEDURE TDCP_blockcipher128.Reset;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized')
  ELSE
    Move(IV,CV,16);
END;

PROCEDURE TDCP_blockcipher128.Burn;
BEGIN
  FillChar(IV,16,$FF);
  FillChar(CV,16,$FF);
  inherited Burn;
END;

PROCEDURE TDCP_blockcipher128.EncryptCBC(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    Move(p1^,p2^,16);
    XorBlock(p2^,CV,16);
    EncryptECB(p2^,p2^);
    Move(p2^,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.DecryptCBC(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
  Temp: ARRAY[0..15] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    Move(p1^,p2^,16);
    Move(p1^,Temp,16);
    DecryptECB(p2^,p2^);
    XorBlock(p2^,CV,16);
    Move(Temp,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.EncryptCFB8bit(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  Temp: ARRAY[0..15] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO Size DO
  BEGIN
    EncryptECB(CV,Temp);
    p2^:= p1^ xor Temp[0];
    Move(CV[1],CV[0],15);
    CV[15]:= p2^;
    Inc(p1);
    Inc(p2);
  END;
END;

PROCEDURE TDCP_blockcipher128.DecryptCFB8bit(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  TempByte: BYTE;
  Temp: ARRAY[0..15] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO Size DO
  BEGIN
    TempByte:= p1^;
    EncryptECB(CV,Temp);
    p2^:= p1^ xor Temp[0];
    Move(CV[1],CV[0],15);
    CV[15]:= TempByte;
    Inc(p1);
    Inc(p2);
  END;
END;

PROCEDURE TDCP_blockcipher128.EncryptCFBblock(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,16);
    XorBlock(p2^,CV,16);
    Move(p2^,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.DecryptCFBblock(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: Pbyte;
  Temp: ARRAY[0..15] OF BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    Move(p1^,Temp,16);
    EncryptECB(CV,CV);
    Move(p1^,p2^,16);
    XorBlock(p2^,CV,16);
    Move(Temp,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.EncryptOFB(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,16);
    XorBlock(p2^,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.DecryptOFB(CONST Indata; VAR Outdata; Size: longword);
VAR
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,16);
    XorBlock(p2^,CV,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,CV);
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,CV,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.EncryptCTR(CONST Indata; VAR Outdata; Size: longword);
VAR
  temp: ARRAY[0..15] OF BYTE;
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,16);
    XorBlock(p2^,temp,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,temp,Size mod 16);
  END;
END;

PROCEDURE TDCP_blockcipher128.DecryptCTR(CONST Indata; VAR Outdata; Size: longword);
VAR
  temp: ARRAY[0..15] OF BYTE;
  i: longword;
  p1, p2: POINTER;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_blockcipher.Create('Cipher not initialized');
  p1:= @@Indata;
  p2:= @@Outdata;
  FOR i:= 1 TO (Size div 16) DO
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,16);
    XorBlock(p2^,temp,16);
    p1:= POINTER(longword(p1) + 16);
    p2:= POINTER(longword(p2) + 16);
  END;
  IF (Size mod 16)<> 0 THEN
  BEGIN
    EncryptECB(CV,temp);
    IncCounter;
    Move(p1^,p2^,Size mod 16);
    XorBlock(p2^,temp,Size mod 16);
  END;
END;

END.
@


1.1
log
@Initial revision
@
text
@d25 1
a25 1
unit ciphers;
d27 2
a28 2
interface
uses
d33 8
a40 8
type
  TDCP_blockcipher64= class(TDCP_blockcipher)
  private
    IV, CV: array[0..7] of byte;

    procedure IncCounter;
  public
    class function GetBlockSize: integer; override;
d43 1
a43 1
    procedure Reset; override;
d45 1
a45 1
    procedure Burn; override;
d47 1
a47 1
    procedure SetIV(const Value); override;
d49 1
a49 1
    procedure GetIV(var Value); override;
d51 1
a51 1
    procedure Init(const Key; Size: longword; InitVector: pointer); override;
d54 1
a54 1
    procedure EncryptCBC(const Indata; var Outdata; Size: longword); override;
d56 1
a56 1
    procedure DecryptCBC(const Indata; var Outdata; Size: longword); override;
d58 1
a58 1
    procedure EncryptCFB8bit(const Indata; var Outdata; Size: longword); override;
d60 1
a60 1
    procedure DecryptCFB8bit(const Indata; var Outdata; Size: longword); override;
d62 1
a62 1
    procedure EncryptCFBblock(const Indata; var Outdata; Size: longword); override;
d64 1
a64 1
    procedure DecryptCFBblock(const Indata; var Outdata; Size: longword); override;
d66 1
a66 1
    procedure EncryptOFB(const Indata; var Outdata; Size: longword); override;
d69 1
a69 1
    procedure DecryptOFB(const Indata; var Outdata; Size: longword); override;
d71 1
a71 1
    procedure EncryptCTR(const Indata; var Outdata; Size: longword); override;
d73 1
a73 1
    procedure DecryptCTR(const Indata; var Outdata; Size: longword); override;
d75 1
a75 1
  end;
d79 8
a86 8
type
  TDCP_blockcipher128= class(TDCP_blockcipher)
  private
    IV, CV: array[0..15] of byte;

    procedure IncCounter;
  public
    class function GetBlockSize: integer; override;
d89 1
a89 1
    procedure Reset; override;
d91 1
a91 1
    procedure Burn; override;
d93 1
a93 1
    procedure SetIV(const Value); override;
d95 1
a95 1
    procedure GetIV(var Value); override;
d97 1
a97 1
    procedure Init(const Key; Size: longword; InitVector: pointer); override;
d100 1
a100 1
    procedure EncryptCBC(const Indata; var Outdata; Size: longword); override;
d102 1
a102 1
    procedure DecryptCBC(const Indata; var Outdata; Size: longword); override;
d104 1
a104 1
    procedure EncryptCFB8bit(const Indata; var Outdata; Size: longword); override;
d106 1
a106 1
    procedure DecryptCFB8bit(const Indata; var Outdata; Size: longword); override;
d108 1
a108 1
    procedure EncryptCFBblock(const Indata; var Outdata; Size: longword); override;
d110 1
a110 1
    procedure DecryptCFBblock(const Indata; var Outdata; Size: longword); override;
d112 1
a112 1
    procedure EncryptOFB(const Indata; var Outdata; Size: longword); override;
d114 1
a114 1
    procedure DecryptOFB(const Indata; var Outdata; Size: longword); override;
d116 1
a116 1
    procedure EncryptCTR(const Indata; var Outdata; Size: longword); override;
d118 1
a118 1
    procedure DecryptCTR(const Indata; var Outdata; Size: longword); override;
d120 1
a120 1
  end;
d122 1
a122 1
implementation
d127 4
a130 4
procedure TDCP_blockcipher64.IncCounter;
var
  i: integer;
begin
d133 2
a134 2
  while (i> 0) and (CV[i] = 0) do
  begin
d137 2
a138 2
  end;
end;
d140 2
a141 2
class function TDCP_blockcipher64.GetBlockSize: integer;
begin
d143 1
a143 1
end;
d145 2
a146 2
procedure TDCP_blockcipher64.Init(const Key; Size: longword; InitVector: pointer);
begin
d149 2
a150 2
  if InitVector= nil then
  begin
d154 3
a156 3
  end
  else
  begin
d159 2
a160 2
  end;
end;
d162 3
a164 3
procedure TDCP_blockcipher64.SetIV(const Value);
begin
  if not fInitialized then
d168 1
a168 1
end;
d170 3
a172 3
procedure TDCP_blockcipher64.GetIV(var Value);
begin
  if not fInitialized then
d175 1
a175 1
end;
d177 3
a179 3
procedure TDCP_blockcipher64.Reset;
begin
  if not fInitialized then
d181 1
a181 1
  else
d183 1
a183 1
end;
d185 2
a186 2
procedure TDCP_blockcipher64.Burn;
begin
d190 1
a190 1
end;
d192 2
a193 2
procedure TDCP_blockcipher64.EncryptCBC(const Indata; var Outdata; Size: longword);
var
d195 3
a197 3
  p1, p2: pointer;
begin
  if not fInitialized then
d201 2
a202 2
  for i:= 1 to (Size div 8) do
  begin
d207 5
a211 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d215 2
a216 2
  end;
end;
d218 2
a219 2
procedure TDCP_blockcipher64.DecryptCBC(const Indata; var Outdata; Size: longword);
var
d221 4
a224 4
  p1, p2: pointer;
  Temp: array[0..7] of byte;
begin
  if not fInitialized then
d228 2
a229 2
  for i:= 1 to (Size div 8) do
  begin
d235 5
a239 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d243 2
a244 2
  end;
end;
d246 2
a247 2
procedure TDCP_blockcipher64.EncryptCFB8bit(const Indata; var Outdata; Size: longword);
var
d250 3
a252 3
  Temp: array[0..7] of byte;
begin
  if not fInitialized then
d256 2
a257 2
  for i:= 1 to Size do
  begin
d264 2
a265 2
  end;
end;
d267 2
a268 2
procedure TDCP_blockcipher64.DecryptCFB8bit(const Indata; var Outdata; Size: longword);
var
d271 4
a274 4
  TempByte: byte;
  Temp: array[0..7] of byte;
begin
  if not fInitialized then
d278 2
a279 2
  for i:= 1 to Size do
  begin
d287 2
a288 2
  end;
end;
d290 2
a291 2
procedure TDCP_blockcipher64.EncryptCFBblock(const Indata; var Outdata; Size: longword);
var
d294 2
a295 2
begin
  if not fInitialized then
d299 2
a300 2
  for i:= 1 to (Size div 8) do
  begin
d305 5
a309 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d313 2
a314 2
  end;
end;
d316 2
a317 2
procedure TDCP_blockcipher64.DecryptCFBblock(const Indata; var Outdata; Size: longword);
var
d320 3
a322 3
  Temp: array[0..7] of byte;
begin
  if not fInitialized then
d326 2
a327 2
  for i:= 1 to (Size div 8) do
  begin
d333 5
a337 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d341 2
a342 2
  end;
end;
d344 2
a345 2
procedure TDCP_blockcipher64.EncryptOFB(const Indata; var Outdata; Size: longword);
var
d347 3
a349 3
  p1, p2: pointer;
begin
  if not fInitialized then
d353 2
a354 2
  for i:= 1 to (Size div 8) do
  begin
d358 5
a362 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d366 2
a367 2
  end;
end;
d369 2
a370 2
procedure TDCP_blockcipher64.DecryptOFB(const Indata; var Outdata; Size: longword);
var
d372 3
a374 3
  p1, p2: pointer;
begin
  if not fInitialized then
d378 2
a379 2
  for i:= 1 to (Size div 8) do
  begin
d383 5
a387 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d391 2
a392 2
  end;
end;
d394 3
a396 3
procedure TDCP_blockcipher64.EncryptCTR(const Indata; var Outdata; Size: longword);
var
  temp: array[0..7] of byte;
d398 3
a400 3
  p1, p2: pointer;
begin
  if not fInitialized then
d404 2
a405 2
  for i:= 1 to (Size div 8) do
  begin
d410 5
a414 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d419 2
a420 2
  end;
end;
d422 3
a424 3
procedure TDCP_blockcipher64.DecryptCTR(const Indata; var Outdata; Size: longword);
var
  temp: array[0..7] of byte;
d426 3
a428 3
  p1, p2: pointer;
begin
  if not fInitialized then
d432 2
a433 2
  for i:= 1 to (Size div 8) do
  begin
d438 5
a442 5
    p1:= pointer(longword(p1) + 8);
    p2:= pointer(longword(p2) + 8);
  end;
  if (Size mod 8)<> 0 then
  begin
d447 2
a448 2
  end;
end;
d452 4
a455 4
procedure TDCP_blockcipher128.IncCounter;
var
  i: integer;
begin
d458 2
a459 2
  while (i> 0) and (CV[i] = 0) do
  begin
d462 2
a463 2
  end;
end;
d465 2
a466 2
class function TDCP_blockcipher128.GetBlockSize: integer;
begin
d468 1
a468 1
end;
d470 2
a471 2
procedure TDCP_blockcipher128.Init(const Key; Size: longword; InitVector: pointer);
begin
d474 2
a475 2
  if InitVector= nil then
  begin
d479 3
a481 3
  end
  else
  begin
d484 2
a485 2
  end;
end;
d487 3
a489 3
procedure TDCP_blockcipher128.SetIV(const Value);
begin
  if not fInitialized then
d493 1
a493 1
end;
d495 3
a497 3
procedure TDCP_blockcipher128.GetIV(var Value);
begin
  if not fInitialized then
d500 1
a500 1
end;
d502 3
a504 3
procedure TDCP_blockcipher128.Reset;
begin
  if not fInitialized then
d506 1
a506 1
  else
d508 1
a508 1
end;
d510 2
a511 2
procedure TDCP_blockcipher128.Burn;
begin
d515 1
a515 1
end;
d517 2
a518 2
procedure TDCP_blockcipher128.EncryptCBC(const Indata; var Outdata; Size: longword);
var
d520 3
a522 3
  p1, p2: pointer;
begin
  if not fInitialized then
d526 2
a527 2
  for i:= 1 to (Size div 16) do
  begin
d532 5
a536 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d540 2
a541 2
  end;
end;
d543 2
a544 2
procedure TDCP_blockcipher128.DecryptCBC(const Indata; var Outdata; Size: longword);
var
d546 4
a549 4
  p1, p2: pointer;
  Temp: array[0..15] of byte;
begin
  if not fInitialized then
d553 2
a554 2
  for i:= 1 to (Size div 16) do
  begin
d560 5
a564 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d568 2
a569 2
  end;
end;
d571 2
a572 2
procedure TDCP_blockcipher128.EncryptCFB8bit(const Indata; var Outdata; Size: longword);
var
d575 3
a577 3
  Temp: array[0..15] of byte;
begin
  if not fInitialized then
d581 2
a582 2
  for i:= 1 to Size do
  begin
d589 2
a590 2
  end;
end;
d592 2
a593 2
procedure TDCP_blockcipher128.DecryptCFB8bit(const Indata; var Outdata; Size: longword);
var
d596 4
a599 4
  TempByte: byte;
  Temp: array[0..15] of byte;
begin
  if not fInitialized then
d603 2
a604 2
  for i:= 1 to Size do
  begin
d612 2
a613 2
  end;
end;
d615 2
a616 2
procedure TDCP_blockcipher128.EncryptCFBblock(const Indata; var Outdata; Size: longword);
var
d619 2
a620 2
begin
  if not fInitialized then
d624 2
a625 2
  for i:= 1 to (Size div 16) do
  begin
d630 5
a634 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d638 2
a639 2
  end;
end;
d641 2
a642 2
procedure TDCP_blockcipher128.DecryptCFBblock(const Indata; var Outdata; Size: longword);
var
d645 3
a647 3
  Temp: array[0..15] of byte;
begin
  if not fInitialized then
d651 2
a652 2
  for i:= 1 to (Size div 16) do
  begin
d658 5
a662 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d666 2
a667 2
  end;
end;
d669 2
a670 2
procedure TDCP_blockcipher128.EncryptOFB(const Indata; var Outdata; Size: longword);
var
d672 3
a674 3
  p1, p2: pointer;
begin
  if not fInitialized then
d678 2
a679 2
  for i:= 1 to (Size div 16) do
  begin
d683 5
a687 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d691 2
a692 2
  end;
end;
d694 2
a695 2
procedure TDCP_blockcipher128.DecryptOFB(const Indata; var Outdata; Size: longword);
var
d697 3
a699 3
  p1, p2: pointer;
begin
  if not fInitialized then
d703 2
a704 2
  for i:= 1 to (Size div 16) do
  begin
d708 5
a712 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d716 2
a717 2
  end;
end;
d719 3
a721 3
procedure TDCP_blockcipher128.EncryptCTR(const Indata; var Outdata; Size: longword);
var
  temp: array[0..15] of byte;
d723 3
a725 3
  p1, p2: pointer;
begin
  if not fInitialized then
d729 2
a730 2
  for i:= 1 to (Size div 16) do
  begin
d735 5
a739 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d744 2
a745 2
  end;
end;
d747 3
a749 3
procedure TDCP_blockcipher128.DecryptCTR(const Indata; var Outdata; Size: longword);
var
  temp: array[0..15] of byte;
d751 3
a753 3
  p1, p2: pointer;
begin
  if not fInitialized then
d757 2
a758 2
  for i:= 1 to (Size div 16) do
  begin
d763 5
a767 5
    p1:= pointer(longword(p1) + 16);
    p2:= pointer(longword(p2) + 16);
  end;
  if (Size mod 16)<> 0 then
  begin
d772 2
a773 2
  end;
end;
d775 1
a775 1
end.
@
