head	1.2;
access;
symbols;
locks;
comment	@ * @;


1.2
date	2006.05.26.15.59.50;	author Average;	state Exp;
branches;
next	1.1;

1.1
date	2006.05.19.16.10.58;	author Average;	state Exp;
branches;
next	;


desc
@@


1.2
log
@ƃC^[tF[Xς܂
@
text
@{******************************************************************************}
{* DCPcrypt v2.0 written by David Barton (crypto@@cityinthesky.co.uk) **********}
{******************************************************************************}
{* A binary compatible implementation of SHA256 *******************************}
{******************************************************************************}
{* Copyright (c) 1999-2002 David Barton                                       *}
{* Permission is hereby granted, free of charge, to any person obtaining a    *}
{* copy of this software and associated documentation files (the "Software"), *}
{* to deal in the Software without restriction, including without limitation  *}
{* the rights to use, copy, modify, merge, publish, distribute, sublicense,   *}
{* and/or sell copies of the Software, and to permit persons to whom the      *}
{* Software is furnished to do so, subject to the following conditions:       *}
{*                                                                            *}
{* The above copyright notice and this permission notice shall be included in *}
{* all copies or substantial portions of the Software.                        *}
{*                                                                            *}
{* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR *}
{* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,   *}
{* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    *}
{* THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER *}
{* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING    *}
{* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER        *}
{* DEALINGS IN THE SOFTWARE.                                                  *}
{******************************************************************************}
UNIT sha256;

INTERFACE
USES
  Classes, Sysutils, crypt2;
CONST
  DCP_Sha256=16;
TYPE
  TDCP_sha256= CLASS(TDCP_hash)
  PROTECTED
    LenHi, LenLo: LONGINT;
    Index: DWord;
    CurrentHash: ARRAY[0..7] OF DWord;
    HashBuffer: ARRAY[0..63] OF BYTE;
    PROCEDURE Compress;
  PUBLIC
    CLASS FUNCTION GetId: INTEGER; override;
    CLASS FUNCTION GetAlgorithm: string; override;
    CLASS FUNCTION GetHashSize: INTEGER; override;
    CLASS FUNCTION SelfTest: BOOLEAN; override;
    PROCEDURE Init; override;
    PROCEDURE Final(VAR Digest); override;
    PROCEDURE Burn; override;
    PROCEDURE Update(CONST Buffer; Size: LONGINT); override;
  END;

{******************************************************************************}
{******************************************************************************}
IMPLEMENTATION
{$R-}{$Q-}

FUNCTION SwapDWord(a: dword): dword;
BEGIN
  Result:= ((a AND $FF) shl 24) OR ((a AND $FF00) shl 8) OR ((a AND $FF0000) shr 8) OR ((a AND $FF000000) shr 24);
END;

PROCEDURE TDCP_sha256.Compress;
VAR
  a, b, c, d, e, f, g, h, t1, t2: DWord;
  W: ARRAY[0..63] OF DWord;
  i: LONGINT;
BEGIN
  Index:= 0;
  a:= CurrentHash[0]; b:= CurrentHash[1]; c:= CurrentHash[2]; d:= CurrentHash[3];
  e:= CurrentHash[4]; f:= CurrentHash[5]; g:= CurrentHash[6]; h:= CurrentHash[7];
  Move(HashBuffer,W,Sizeof(HashBuffer));
  FOR i:= 0 TO 15 DO
    W[i]:= SwapDWord(W[i]);
  FOR i:= 16 TO 63 DO
    W[i]:= (((W[i-2] shr 17) OR (W[i-2] shl 15)) xor ((W[i-2] shr 19) OR (W[i-2] shl 13)) xor
      (W[i-2] shr 10)) + W[i-7] + (((W[i-15] shr 7) OR (W[i-15] shl 25)) xor
      ((W[i-15] shr 18) OR (W[i-15] shl 14)) xor (W[i-15] shr 3)) + W[i-16];
{
Non-optimised version
  for i:= 0 to 63 do
  begin
    t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) +
      ((e and f) xor (not e and g)) + K[i] + W[i];
    t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) +
      ((a and b) xor (a and c) xor (b and c));
    h:= g; g:= f; f:= e; e:= d + t1; d:= c; c:= b; b:= a; a:= t1 + t2;
  end;
}

  t1:= h + (((e shr 6) OR (e shl 26)) xor
            ((e shr 11) OR (e shl 21)) xor
            ((e shr 25) OR (e shl 7))) +
            ((e AND f) xor (NOT e AND g)) + $428a2f98 + W[0];
  t2:= (((a shr 2) OR (a shl 30)) xor
        ((a shr 13) OR (a shl 19)) xor
        ((a shr 22) xor (a shl 10))) + ((a AND b) xor (a AND c) xor (b AND c));
  h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $71374491 + W[1];
 t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h AND a) xor (h AND b) xor (a AND b));
  g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $b5c0fbcf + W[2];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g AND h) xor (g AND a) xor (h AND a));
  f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $e9b5dba5 + W[3];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f AND g) xor (f AND h) xor (g AND h));
  e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $3956c25b + W[4];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e AND f) xor (e AND g) xor (f AND g));
  d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $59f111f1 + W[5];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d AND e) xor (d AND f) xor (e AND f));
  c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $923f82a4 + W[6];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c AND d) xor (c AND e) xor (d AND e));
  b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $ab1c5ed5 + W[7];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b AND c) xor (b AND d) xor (c AND d));
 a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $d807aa98 + W[8];
 t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a AND b) xor (a AND c) xor (b AND c));
 h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $12835b01 + W[9];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h AND a) xor (h AND b) xor (a AND b));
  g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $243185be + W[10];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g AND h) xor (g AND a) xor (h AND a));
  f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $550c7dc3 + W[11];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f AND g) xor (f AND h) xor (g AND h));
  e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $72be5d74 + W[12];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e AND f) xor (e AND g) xor (f AND g));
  d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $80deb1fe + W[13];
 t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d AND e) xor (d AND f) xor (e AND f));
  c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $9bdc06a7 + W[14];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c AND d) xor (c AND e) xor (d AND e));
  b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $c19bf174 + W[15];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b AND c) xor (b AND d) xor (c AND d));
  a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $e49b69c1 + W[16];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a AND b) xor (a AND c) xor (b AND c));
  h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $efbe4786 + W[17];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h AND a) xor (h AND b) xor (a AND b));
  g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $0fc19dc6 + W[18];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g AND h) xor (g AND a) xor (h AND a));
  f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $240ca1cc + W[19];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f AND g) xor (f AND h) xor (g AND h));
  e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $2de92c6f + W[20];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e AND f) xor (e AND g) xor (f AND g));
  d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $4a7484aa + W[21];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d AND e) xor (d AND f) xor (e AND f));
  c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $5cb0a9dc + W[22];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c AND d) xor (c AND e) xor (d AND e));
  b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $76f988da + W[23];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b AND c) xor (b AND d) xor (c AND d));
a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $983e5152 + W[24];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a AND b) xor (a AND c) xor (b AND c));
  h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $a831c66d + W[25];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h AND a) xor (h AND b) xor (a AND b));
  g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $b00327c8 + W[26];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g AND h) xor (g AND a) xor (h AND a));
  f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $bf597fc7 + W[27];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f AND g) xor (f AND h) xor (g AND h));
  e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $c6e00bf3 + W[28];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e AND f) xor (e AND g) xor (f AND g));
  d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $d5a79147 + W[29];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d AND e) xor (d AND f) xor (e AND f));
 c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $06ca6351 + W[30];
   t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
AND d) xor (c AND e) xor (d AND e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $14292967 + W[31];
   t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
AND c) xor (b AND d) xor (c AND d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $27b70a85 + W[32];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
AND b) xor (a AND c) xor (b AND c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $2e1b2138 + W[33];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
AND a) xor (h AND b) xor (a AND b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $4d2c6dfc + W[34];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
AND h) xor (g AND a) xor (h AND a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $53380d13 + W[35];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
AND g) xor (f AND h) xor (g AND h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $650a7354 + W[36];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
AND f) xor (e AND g) xor (f AND g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $766a0abb + W[37];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
AND e) xor (d AND f) xor (e AND f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $81c2c92e + W[38];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
AND d) xor (c AND e) xor (d AND e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $92722c85 + W[39];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
AND c) xor (b AND d) xor (c AND d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $a2bfe8a1 + W[40];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
AND b) xor (a AND c) xor (b AND c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $a81a664b + W[41];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
AND a) xor (h AND b) xor (a AND b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $c24b8b70 + W[42];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
AND h) xor (g AND a) xor (h AND a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $c76c51a3 + W[43];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
AND g) xor (f AND h) xor (g AND h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $d192e819 + W[44];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
AND f) xor (e AND g) xor (f AND g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $d6990624 + W[45];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
AND e) xor (d AND f) xor (e AND f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $f40e3585 + W[46];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
AND d) xor (c AND e) xor (d AND e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $106aa070 + W[47];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
AND c) xor (b AND d) xor (c AND d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $19a4c116 + W[48];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
AND b) xor (a AND c) xor (b AND c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $1e376c08 + W[49];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
AND a) xor (h AND b) xor (a AND b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $2748774c + W[50];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
AND h) xor (g AND a) xor (h AND a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $34b0bcb5 + W[51];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
AND g) xor (f AND h) xor (g AND h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $391c0cb3 + W[52];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
AND f) xor (e AND g) xor (f AND g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $4ed8aa4a + W[53];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
AND e) xor (d AND f) xor (e AND f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $5b9cca4f + W[54];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
AND d) xor (c AND e) xor (d AND e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $682e6ff3 + W[55];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
AND c) xor (b AND d) xor (c AND d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) OR (e shl 26)) xor ((e shr 11) OR (e shl 21)) xor ((e shr 25) OR (e shl 7))) + ((e AND f) xor (NOT e AND g)) + $748f82ee + W[56];
  t2:= (((a shr 2) OR (a shl 30)) xor ((a shr 13) OR (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
AND b) xor (a AND c) xor (b AND c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) OR (d shl 26)) xor ((d shr 11) OR (d shl 21)) xor ((d shr 25) OR (d shl 7))) + ((d AND e) xor (NOT d AND f)) + $78a5636f + W[57];
  t2:= (((h shr 2) OR (h shl 30)) xor ((h shr 13) OR (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
AND a) xor (h AND b) xor (a AND b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) OR (c shl 26)) xor ((c shr 11) OR (c shl 21)) xor ((c shr 25) OR (c shl 7))) + ((c AND d) xor (NOT c AND e)) + $84c87814 + W[58];
  t2:= (((g shr 2) OR (g shl 30)) xor ((g shr 13) OR (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
AND h) xor (g AND a) xor (h AND a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) OR (b shl 26)) xor ((b shr 11) OR (b shl 21)) xor ((b shr 25) OR (b shl 7))) + ((b AND c) xor (NOT b AND d)) + $8cc70208 + W[59];
  t2:= (((f shr 2) OR (f shl 30)) xor ((f shr 13) OR (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
AND g) xor (f AND h) xor (g AND h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) OR (a shl 26)) xor ((a shr 11) OR (a shl 21)) xor ((a shr 25) OR (a shl 7))) + ((a AND b) xor (NOT a AND c)) + $90befffa + W[60];
  t2:= (((e shr 2) OR (e shl 30)) xor ((e shr 13) OR (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
AND f) xor (e AND g) xor (f AND g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) OR (h shl 26)) xor ((h shr 11) OR (h shl 21)) xor ((h shr 25) OR (h shl 7))) + ((h AND a) xor (NOT h AND b)) + $a4506ceb + W[61];
  t2:= (((d shr 2) OR (d shl 30)) xor ((d shr 13) OR (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
AND e) xor (d AND f) xor (e AND f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) OR (g shl 26)) xor ((g shr 11) OR (g shl 21)) xor ((g shr 25) OR (g shl 7))) + ((g AND h) xor (NOT g AND a)) + $bef9a3f7 + W[62];
  t2:= (((c shr 2) OR (c shl 30)) xor ((c shr 13) OR (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
AND d) xor (c AND e) xor (d AND e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) OR (f shl 26)) xor ((f shr 11) OR (f shl 21)) xor ((f shr 25) OR (f shl 7))) + ((f AND g) xor (NOT f AND h)) + $c67178f2 + W[63];
  t2:= (((b shr 2) OR (b shl 30)) xor ((b shr 13) OR (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
AND c) xor (b AND d) xor (c AND d)); a:= t1 + t2; e:= e + t1;

  CurrentHash[0]:= CurrentHash[0] + a;
  CurrentHash[1]:= CurrentHash[1] + b;
  CurrentHash[2]:= CurrentHash[2] + c;
  CurrentHash[3]:= CurrentHash[3] + d;
  CurrentHash[4]:= CurrentHash[4] + e;
  CurrentHash[5]:= CurrentHash[5] + f;
  CurrentHash[6]:= CurrentHash[6] + g;
  CurrentHash[7]:= CurrentHash[7] + h;
  FillChar(W,Sizeof(W),0);
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
END;

CLASS FUNCTION TDCP_sha256.GetAlgorithm: string;
BEGIN
  Result:= 'SHA256';
END;

CLASS FUNCTION TDCP_sha256.GetId: INTEGER;
BEGIN
  Result:= DCP_sha256;
END;

CLASS FUNCTION TDCP_sha256.GetHashSize: INTEGER;
BEGIN
  Result:= 256;
END;

CLASS FUNCTION TDCP_sha256.SelfTest: BOOLEAN;
CONST
  Test1Out: ARRAY[0..31] OF BYTE=
    ($ba,$78,$16,$bf,$8f,$01,$cf,$ea,$41,$41,$40,$de,$5d,$ae,$22,$23,
     $b0,$03,$61,$a3,$96,$17,$7a,$9c,$b4,$10,$ff,$61,$f2,$00,$15,$ad);
  Test2Out: ARRAY[0..31] OF BYTE=
    ($24,$8d,$6a,$61,$d2,$06,$38,$b8,$e5,$c0,$26,$93,$0c,$3e,$60,$39,
     $a3,$3c,$e4,$59,$64,$ff,$21,$67,$f6,$ec,$ed,$d4,$19,$db,$06,$c1);
VAR
  TestHash: TDCP_sha256;
  TestOut: ARRAY[0..31] OF BYTE;
BEGIN
  TestHash:= TDCP_sha256.Create;
  TestHash.Init;
  TestHash.UpdateStr('abc');
  TestHash.Final(TestOut);
  Result:= BOOLEAN(CompareMem(@@TestOut,@@Test1Out,Sizeof(Test1Out)));
  TestHash.Init;
  TestHash.UpdateStr('abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq');
  TestHash.Final(TestOut);
  Result:= BOOLEAN(CompareMem(@@TestOut,@@Test2Out,Sizeof(Test2Out))) AND Result;
  TestHash.Free;
END;

PROCEDURE TDCP_sha256.Init;
BEGIN
  Burn;
  CurrentHash[0]:= $6a09e667;
  CurrentHash[1]:= $bb67ae85;
  CurrentHash[2]:= $3c6ef372;
  CurrentHash[3]:= $a54ff53a;
  CurrentHash[4]:= $510e527f;
  CurrentHash[5]:= $9b05688c;
  CurrentHash[6]:= $1f83d9ab;
  CurrentHash[7]:= $5be0cd19;
  fInitialized:= true;
END;

PROCEDURE TDCP_sha256.Burn;
BEGIN
  LenHi:= 0; LenLo:= 0;
  Index:= 0;
  FillChar(HashBuffer,Sizeof(HashBuffer),0);
  FillChar(CurrentHash,Sizeof(CurrentHash),0);
  fInitialized:= FALSE;
END;

PROCEDURE TDCP_sha256.Update(CONST Buffer; Size: LONGINT);
VAR
  PBuf: ^BYTE;
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_hash.Create('Hash not initialized');

  Inc(LenHi,Size shr 29);
  Inc(LenLo,Size*8);
  IF LenLo< (Size*8) THEN
    Inc(LenHi);

  PBuf:= @@Buffer;
  WHILE Size> 0 DO
  BEGIN
    IF (Sizeof(HashBuffer)-Index)<= DWord(Size) THEN
    BEGIN
      Move(PBuf^,HashBuffer[Index],Sizeof(HashBuffer)-Index);
      Dec(Size,Sizeof(HashBuffer)-Index);
      Inc(PBuf,Sizeof(HashBuffer)-Index);
      Compress;
    END
    ELSE
    BEGIN
      Move(PBuf^,HashBuffer[Index],Size);
      Inc(Index,Size);
      Size:= 0;
    END;
  END;
END;

PROCEDURE TDCP_sha256.Final(VAR Digest);
BEGIN
  IF NOT fInitialized THEN
    raise EDCP_hash.Create('Hash not initialized');
  HashBuffer[Index]:= $80;
  IF Index>= 56 THEN
    Compress;
  PDWord(@@HashBuffer[56])^:= SwapDWord(LenHi);
  PDWord(@@HashBuffer[60])^:= SwapDWord(LenLo);
  Compress;
  CurrentHash[0]:= SwapDWord(CurrentHash[0]);
  CurrentHash[1]:= SwapDWord(CurrentHash[1]);
  CurrentHash[2]:= SwapDWord(CurrentHash[2]);
  CurrentHash[3]:= SwapDWord(CurrentHash[3]);
  CurrentHash[4]:= SwapDWord(CurrentHash[4]);
  CurrentHash[5]:= SwapDWord(CurrentHash[5]);
  CurrentHash[6]:= SwapDWord(CurrentHash[6]);
  CurrentHash[7]:= SwapDWord(CurrentHash[7]);
  Move(CurrentHash,Digest,Sizeof(CurrentHash));
  Burn;
END;

END.
@


1.1
log
@Initial revision
@
text
@d25 1
a25 1
unit sha256;
d27 2
a28 2
interface
uses
d30 1
a30 1
const
d32 4
a35 4
type
  TDCP_sha256= class(TDCP_hash)
  protected
    LenHi, LenLo: LongInt;
d37 13
a49 13
    CurrentHash: array[0..7] of DWord;
    HashBuffer: array[0..63] of byte;
    procedure Compress;
  public
    class function GetId: integer; override;
    class function GetAlgorithm: string; override;
    class function GetHashSize: integer; override;
    class function SelfTest: boolean; override;
    procedure Init; override;
    procedure Final(var Digest); override;
    procedure Burn; override;
    procedure Update(const Buffer; Size: LongInt); override;
  end;
d53 1
a53 1
implementation
d56 4
a59 4
function SwapDWord(a: dword): dword;
begin
  Result:= ((a and $FF) shl 24) or ((a and $FF00) shl 8) or ((a and $FF0000) shr 8) or ((a and $FF000000) shr 24);
end;
d61 2
a62 2
procedure TDCP_sha256.Compress;
var
d64 3
a66 3
  W: array[0..63] of DWord;
  i: LongInt;
begin
d71 1
a71 1
  for i:= 0 to 15 do
d73 4
a76 4
  for i:= 16 to 63 do
    W[i]:= (((W[i-2] shr 17) or (W[i-2] shl 15)) xor ((W[i-2] shr 19) or (W[i-2] shl 13)) xor
      (W[i-2] shr 10)) + W[i-7] + (((W[i-15] shr 7) or (W[i-15] shl 25)) xor
      ((W[i-15] shr 18) or (W[i-15] shl 14)) xor (W[i-15] shr 3)) + W[i-16];
d89 7
a95 7
  t1:= h + (((e shr 6) or (e shl 26)) xor
            ((e shr 11) or (e shl 21)) xor
            ((e shr 25) or (e shl 7))) +
            ((e and f) xor (not e and g)) + $428a2f98 + W[0];
  t2:= (((a shr 2) or (a shl 30)) xor
        ((a shr 13) or (a shl 19)) xor
        ((a shr 22) xor (a shl 10))) + ((a and b) xor (a and c) xor (b and c));
d97 2
a98 2
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $71374491 + W[1];
 t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h and a) xor (h and b) xor (a and b));
d100 2
a101 2
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $b5c0fbcf + W[2];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g and h) xor (g and a) xor (h and a));
d103 2
a104 2
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $e9b5dba5 + W[3];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f and g) xor (f and h) xor (g and h));
d106 2
a107 2
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $3956c25b + W[4];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e and f) xor (e and g) xor (f and g));
d109 2
a110 2
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $59f111f1 + W[5];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d and e) xor (d and f) xor (e and f));
d112 2
a113 2
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $923f82a4 + W[6];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c and d) xor (c and e) xor (d and e));
d115 2
a116 2
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $ab1c5ed5 + W[7];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b and c) xor (b and d) xor (c and d));
d118 2
a119 2
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $d807aa98 + W[8];
 t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a and b) xor (a and c) xor (b and c));
d121 2
a122 2
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $12835b01 + W[9];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h and a) xor (h and b) xor (a and b));
d124 2
a125 2
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $243185be + W[10];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g and h) xor (g and a) xor (h and a));
d127 2
a128 2
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $550c7dc3 + W[11];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f and g) xor (f and h) xor (g and h));
d130 2
a131 2
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $72be5d74 + W[12];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e and f) xor (e and g) xor (f and g));
d133 2
a134 2
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $80deb1fe + W[13];
 t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d and e) xor (d and f) xor (e and f));
d136 2
a137 2
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $9bdc06a7 + W[14];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c and d) xor (c and e) xor (d and e));
d139 2
a140 2
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $c19bf174 + W[15];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b and c) xor (b and d) xor (c and d));
d142 2
a143 2
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $e49b69c1 + W[16];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a and b) xor (a and c) xor (b and c));
d145 2
a146 2
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $efbe4786 + W[17];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h and a) xor (h and b) xor (a and b));
d148 2
a149 2
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $0fc19dc6 + W[18];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g and h) xor (g and a) xor (h and a));
d151 2
a152 2
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $240ca1cc + W[19];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f and g) xor (f and h) xor (g and h));
d154 2
a155 2
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $2de92c6f + W[20];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e and f) xor (e and g) xor (f and g));
d157 2
a158 2
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $4a7484aa + W[21];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d and e) xor (d and f) xor (e and f));
d160 2
a161 2
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $5cb0a9dc + W[22];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c and d) xor (c and e) xor (d and e));
d163 2
a164 2
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $76f988da + W[23];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b and c) xor (b and d) xor (c and d));
d166 2
a167 2
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $983e5152 + W[24];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a and b) xor (a and c) xor (b and c));
d169 2
a170 2
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $a831c66d + W[25];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h and a) xor (h and b) xor (a and b));
d172 2
a173 2
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $b00327c8 + W[26];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g and h) xor (g and a) xor (h and a));
d175 2
a176 2
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $bf597fc7 + W[27];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f and g) xor (f and h) xor (g and h));
d178 2
a179 2
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $c6e00bf3 + W[28];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e and f) xor (e and g) xor (f and g));
d181 2
a182 2
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $d5a79147 + W[29];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d and e) xor (d and f) xor (e and f));
d184 102
a285 102
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $06ca6351 + W[30];
   t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
and d) xor (c and e) xor (d and e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $14292967 + W[31];
   t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
and c) xor (b and d) xor (c and d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $27b70a85 + W[32];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
and b) xor (a and c) xor (b and c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $2e1b2138 + W[33];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
and a) xor (h and b) xor (a and b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $4d2c6dfc + W[34];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
and h) xor (g and a) xor (h and a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $53380d13 + W[35];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
and g) xor (f and h) xor (g and h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $650a7354 + W[36];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
and f) xor (e and g) xor (f and g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $766a0abb + W[37];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
and e) xor (d and f) xor (e and f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $81c2c92e + W[38];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
and d) xor (c and e) xor (d and e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $92722c85 + W[39];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
and c) xor (b and d) xor (c and d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $a2bfe8a1 + W[40];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
and b) xor (a and c) xor (b and c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $a81a664b + W[41];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
and a) xor (h and b) xor (a and b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $c24b8b70 + W[42];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
and h) xor (g and a) xor (h and a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $c76c51a3 + W[43];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
and g) xor (f and h) xor (g and h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $d192e819 + W[44];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
and f) xor (e and g) xor (f and g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $d6990624 + W[45];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
and e) xor (d and f) xor (e and f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $f40e3585 + W[46];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
and d) xor (c and e) xor (d and e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $106aa070 + W[47];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
and c) xor (b and d) xor (c and d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $19a4c116 + W[48];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
and b) xor (a and c) xor (b and c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $1e376c08 + W[49];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
and a) xor (h and b) xor (a and b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $2748774c + W[50];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
and h) xor (g and a) xor (h and a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $34b0bcb5 + W[51];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
and g) xor (f and h) xor (g and h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $391c0cb3 + W[52];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
and f) xor (e and g) xor (f and g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $4ed8aa4a + W[53];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
and e) xor (d and f) xor (e and f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $5b9cca4f + W[54];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
and d) xor (c and e) xor (d and e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $682e6ff3 + W[55];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
and c) xor (b and d) xor (c and d)); a:= t1 + t2; e:= e + t1;
  t1:= h + (((e shr 6) or (e shl 26)) xor ((e shr 11) or (e shl 21)) xor ((e shr 25) or (e shl 7))) + ((e and f) xor (not e and g)) + $748f82ee + W[56];
  t2:= (((a shr 2) or (a shl 30)) xor ((a shr 13) or (a shl 19)) xor ((a shr 22) xor (a shl 10))) + ((a
and b) xor (a and c) xor (b and c)); h:= t1 + t2; d:= d + t1;
  t1:= g + (((d shr 6) or (d shl 26)) xor ((d shr 11) or (d shl 21)) xor ((d shr 25) or (d shl 7))) + ((d and e) xor (not d and f)) + $78a5636f + W[57];
  t2:= (((h shr 2) or (h shl 30)) xor ((h shr 13) or (h shl 19)) xor ((h shr 22) xor (h shl 10))) + ((h
and a) xor (h and b) xor (a and b)); g:= t1 + t2; c:= c + t1;
  t1:= f + (((c shr 6) or (c shl 26)) xor ((c shr 11) or (c shl 21)) xor ((c shr 25) or (c shl 7))) + ((c and d) xor (not c and e)) + $84c87814 + W[58];
  t2:= (((g shr 2) or (g shl 30)) xor ((g shr 13) or (g shl 19)) xor ((g shr 22) xor (g shl 10))) + ((g
and h) xor (g and a) xor (h and a)); f:= t1 + t2; b:= b + t1;
  t1:= e + (((b shr 6) or (b shl 26)) xor ((b shr 11) or (b shl 21)) xor ((b shr 25) or (b shl 7))) + ((b and c) xor (not b and d)) + $8cc70208 + W[59];
  t2:= (((f shr 2) or (f shl 30)) xor ((f shr 13) or (f shl 19)) xor ((f shr 22) xor (f shl 10))) + ((f
and g) xor (f and h) xor (g and h)); e:= t1 + t2; a:= a + t1;
  t1:= d + (((a shr 6) or (a shl 26)) xor ((a shr 11) or (a shl 21)) xor ((a shr 25) or (a shl 7))) + ((a and b) xor (not a and c)) + $90befffa + W[60];
  t2:= (((e shr 2) or (e shl 30)) xor ((e shr 13) or (e shl 19)) xor ((e shr 22) xor (e shl 10))) + ((e
and f) xor (e and g) xor (f and g)); d:= t1 + t2; h:= h + t1;
  t1:= c + (((h shr 6) or (h shl 26)) xor ((h shr 11) or (h shl 21)) xor ((h shr 25) or (h shl 7))) + ((h and a) xor (not h and b)) + $a4506ceb + W[61];
  t2:= (((d shr 2) or (d shl 30)) xor ((d shr 13) or (d shl 19)) xor ((d shr 22) xor (d shl 10))) + ((d
and e) xor (d and f) xor (e and f)); c:= t1 + t2; g:= g + t1;
  t1:= b + (((g shr 6) or (g shl 26)) xor ((g shr 11) or (g shl 21)) xor ((g shr 25) or (g shl 7))) + ((g and h) xor (not g and a)) + $bef9a3f7 + W[62];
  t2:= (((c shr 2) or (c shl 30)) xor ((c shr 13) or (c shl 19)) xor ((c shr 22) xor (c shl 10))) + ((c
and d) xor (c and e) xor (d and e)); b:= t1 + t2; f:= f + t1;
  t1:= a + (((f shr 6) or (f shl 26)) xor ((f shr 11) or (f shl 21)) xor ((f shr 25) or (f shl 7))) + ((f and g) xor (not f and h)) + $c67178f2 + W[63];
  t2:= (((b shr 2) or (b shl 30)) xor ((b shr 13) or (b shl 19)) xor ((b shr 22) xor (b shl 10))) + ((b
and c) xor (b and d) xor (c and d)); a:= t1 + t2; e:= e + t1;
d297 1
a297 1
end;
d299 2
a300 2
class function TDCP_sha256.GetAlgorithm: string;
begin
d302 1
a302 1
end;
d304 2
a305 2
class function TDCP_sha256.GetId: integer;
begin
d307 1
a307 1
end;
d309 2
a310 2
class function TDCP_sha256.GetHashSize: integer;
begin
d312 1
a312 1
end;
d314 3
a316 3
class function TDCP_sha256.SelfTest: boolean;
const
  Test1Out: array[0..31] of byte=
d319 1
a319 1
  Test2Out: array[0..31] of byte=
d322 1
a322 1
var
d324 2
a325 2
  TestOut: array[0..31] of byte;
begin
d330 1
a330 1
  Result:= boolean(CompareMem(@@TestOut,@@Test1Out,Sizeof(Test1Out)));
d334 1
a334 1
  Result:= boolean(CompareMem(@@TestOut,@@Test2Out,Sizeof(Test2Out))) and Result;
d336 1
a336 1
end;
d338 2
a339 2
procedure TDCP_sha256.Init;
begin
d350 1
a350 1
end;
d352 2
a353 2
procedure TDCP_sha256.Burn;
begin
d358 2
a359 2
  fInitialized:= false;
end;
d361 5
a365 5
procedure TDCP_sha256.Update(const Buffer; Size: LongInt);
var
  PBuf: ^byte;
begin
  if not fInitialized then
d370 1
a370 1
  if LenLo< (Size*8) then
d374 4
a377 4
  while Size> 0 do
  begin
    if (Sizeof(HashBuffer)-Index)<= DWord(Size) then
    begin
d382 3
a384 3
    end
    else
    begin
d388 7
a394 7
    end;
  end;
end;

procedure TDCP_sha256.Final(var Digest);
begin
  if not fInitialized then
d397 1
a397 1
  if Index>= 56 then
d412 1
a412 1
end;
d414 1
a414 1
end.
@
