(**$Revision: 1.1.1.1 $**)
PROGRAM Krmini;
USES
    Classes,os2def,os2pmapi,
    SysUtils,VPUtils,
    Cell,xmlRead,xmlWrite,dom,
    KrDialog,KrUnit;

{$PMTYPE PM}
{$R krmini.res}
{$I krmini.inc}
TYPE
    FilterCommandRecord=RECORD
        isFilter:BOOLEAN;
    END;
    pFilterCommand=^FilterCommandRecord;

FUNCTION MainClientProc(Window:
                        HWnd; Msg:
                        ULong;
                        Mp1,Mp2: MParam): MResult; cdecl; forward;

FUNCTION ContainerClientProc(Window:
                             HWnd; Msg:
                             ULong;
                             Mp1,Mp2: MParam): MResult; cdecl; forward;

(**GUI Cell Definition**)
CONST
    AppTitle='KeyRingMini';
    cdCntPane:CellDef =
        (lType: Cell_WINDOW;
         pszClass:WC_CONTAINER;
         pszName:'test';
         ulStyle:CCS_SINGLESEL OR WS_VISIBLE;
         ulID:ID_CONTAINER);

    nbClient:CellDef =
        (lType:CELL_VSPLIT ;
         pszClass:NIL;
         pszName:'Notebook page';
         ulStyle:0;
         ulID:MAIN_FRAME;
         pPanel1:@cdCntPane;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:ContainerClientProc);

    nbConigClient:CellDef=
        (lType:CELL_VSPLIT ;
         pszClass:NIL;
         pszName:'Notebook page';
         ulStyle:0;
         ulID:MAIN_FRAME;
         pPanel1:NIL;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:NIL);

    nbPanel:CellDef=
        (lType:CELL_WINDOW;
         pszClass:WC_NOTEBOOK;
         pszName:'';
         ulStyle:WS_VISIBLE OR BKS_TABBEDDIALOG OR BKS_MAJORTABTOP;
         ulID:ID_NOTEBOOK);

    mainFrame:CellDef=
        (lType:CELL_HSPLIT;
         pszClass:NIL;
         pszName:AppTitle+'   --$Revision: 1.1.1.1 $--';
         ulStyle:FCF_TITLEBAR OR FCF_SYSMENU OR FCF_MENU OR FCF_ICON OR
                 FCF_MINMAX OR FCF_TASKLIST OR FCF_SIZEBORDER;
         ulID:MAIN_FRAME;
         pPanel1:@nbPanel;
         pPanel2:NIL;
         pClassProc:NIL;
         pClientClassProc:MainClientProc);

    mainItems:ARRAY [0..12] OF LONGINT=
        (IDB_FILEOPEN,
         IDB_FILESAVE,
         IDB_FILSAVAS,
         TB_SEPARATOR,
         IDB_PAGECONF,
         IDB_CONFIG,
         ID_FilterExpire,
         IDB_Exec,
         TB_SEPARATOR,
         IDB_EXIT    ,
         TB_SEPARATOR,
         IDB_LOCK    ,
         0);

    mainTb:TbDef=
        (lType:TB_ATTACHED_TP OR TB_BUBBLE;
         ulID:ID_TOOLBAR;
         tbItems:@mainItems);

FUNCTION FindFile(hwndClient:HWnd;VAR FileSt:String;isCrypt:BOOLEAN):Bool;
VAR
    fdFileDlg:Os2PmApi.FileDlg;
    pCh:pChar;
BEGIN
    Fillchar( fdFileDlg, sizeof(fdFileDlg), 0);
    fdFileDlg.cbSize := sizeof(Os2PmApi.FileDlg);
    fdFileDlg.fl := FDS_CENTER OR FDS_PRELOAD_VOLINFO OR FDS_OPEN_DIALOG;
    GetMem(pCh,MaxCharLength);
    IF isCrypt THEN
        pCh:='*.crp'
    ELSE
        pCh:='*.xml';
    StrCopy(fdFileDlg.szFullFile,pCh);

    WinFileDlg( HWND_DESKTOP,hwndClient,fdFileDlg );
    FileSt:=StrPas( fdFileDlg.szFullFile);
    IF (FileSt='*.xml') OR (FileSt='*.crp') OR (FileSt='') THEN BEGIN
        FindFile := FALSE;
    END
    ELSE BEGIN
        FindFile := TRUE;
    END;
END; { FindFile }

FUNCTION FilterExpire( pRow: pRowInfo;
                        pCommand: pFilterCommand) : Bool; cdecl;
VAR
    st:string;
    EvalDate:TDateTime;
    y,m,d:SmallWord;
BEGIN
    IF pCommand^.isFilter=FALSE THEN
        FilterExpire:=TRUE
    ELSE BEGIN
        IF (pRow^.isExpireCheck=FALSE) THEN BEGIN
            FilterExpire:=FALSE;
        END
        ELSE BEGIN
            IF isBlankpCh(pRow^.pChAry[9]) THEN BEGIN
                FilterExpire:=FALSE;
            END
            ELSE BEGIN
                EvalDate:=StrToDate(StrPas(pRow^.pChAry[9]));
                DecodeDate(EvalDate,y,m,d);
                EvalDate:=Now-EvalDate;
                FilterExpire:=(EvalDate>0);
            END;
        END
    END;
END;

FUNCTION SortByColum(pRowFirst,pROwSecond:pRowInfo;
                     pSortOffset:pSmallInt):SmallInt; cdecl;
VAR
    p1,p2:pChar;
BEGIN
    IF pSortOffset^=2 THEN BEGIN
        p1:=pRowFirst^.Core.pszIcon;
        p2:=pRowSecond^.Core.pszIcon;
    END
    ELSE BEGIN
        p1:=pRowFirst^.pChAry[pSortOffset^];
        p2:=pRowSecond^.pChAry[pSortOffset^];
    END;
    IF p1=NIL THEN p1:='';
    IF p2=NIL THEN p2:='';
    SortByColum:=StrComp( p1,p2);
END; { SortRecords }


VAR
    KrPageMan:KrPageManegerClass;
FUNCTION MainClientProc(Window: HWnd; Msg: ULong; Mp1,Mp2: MParam): MResult;
VAR
    pWCtlData:PWindowCellCtlData;
    i:INTEGER;
    j:ShortInt;
    k:ULong;
    node:TDOMNode;
    pRow:pRowInfo;
    hptrIcon:HPointer;
    CurCntr:ContainerClass;
    CurPageID:ULong;
    ParamCommand:FilterCommandRecord;
    bkCol,rc:ULong;
    St,OrgSt:String;
BEGIN
    pWCtlData:=PWindowCellCtlData(WinQueryWindowULong(Window,QWL_USER));
    result   :=0;
    CASE msg OF
        WM_CREATE:BEGIN
        END;
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                IDB_EXIT:BEGIN
                    KrPageMan.FlushSave;
                    WinPostMsg(Window, WM_QUIT, 0, 1);
                END;
                IDB_VIEWDETAIL:BEGIN
                    KrPageMan.GetCurCntr.SetStyle(  CV_DETAIL OR
                                                    CA_DETAILSVIEWTITLES );

                END;
                IDB_VIEWICON:BEGIN
                    KrPageMan.GetCurCntr.SetStyle(  CV_ICON OR
                                                    CA_DETAILSVIEWTITLES );
                END;
                IDB_VIEWSMALLICON:BEGIN
                    KrPageMan.GetCurCntr.SetStyle(  CV_ICON OR
                                          CV_MINI OR
                                          CA_DETAILSVIEWTITLES );
                END;
                IDB_FILEOPEN:BEGIN
                    IF FindFile(KrPageMan.FrameWindow,
                                St,
                                KrPageMan.DataDoc.isUseCrypt) THEN BEGIN
                        KrPageMan.FlushSave;
                        KrPageMan.FlushAllPage;
                        KrPageMan.LoadData(st,nbClient);
                    END;
                END;
                ID_FILEIMPORT:BEGIN
                    OrgSt:=KrPageMan.DataDoc.GetFileName;
                    IF FindFile(KrPageMan.FrameWindow,St,FALSE) THEN BEGIN
                        KrPageMan.ImportData(st,nbClient);
                        KrPageMan.SetDocName(OrgSt);
                        KrPageMan.DataDoc.FlushXMLData;
                    END;
                END;
                IDB_FILESAVE:BEGIN
                    KrPageMan.FlushSave;
                END;
                IDB_FILSAVAS:BEGIN
                    IF FindFile(KrPageMan.FrameWindow,
                                St,
                                KrPageMan.DataDoc.isUseCrypt) THEN BEGIN
                        KrPageMan.SetDocName(st);
                        KrPageMan.FlushSave;
                    END;
                END;
                ID_FILEEXPORT:BEGIN
                    IF FindFile(KrPageMan.FrameWindow,St,FALSE) THEN BEGIN
                        KrPageMan.SetDocName(st);
                        KrPageMan.FlushSave;
                    END;
                END;
                ID_NewPage:BEGIN
                    KrPageMan.CreateBlankPage(nbClient);
                    CurCntr:=
                        ContainerClass(KrPageMan.ContainerList[
                                          KrPageMan.ContainerList.Count-1]);
                    WinSendMsg(KrPageMan.hwndNb,
                               BKM_TURNTOPAGE,
                               CurCntr.id,
                               CurCntr.Gethwnd);
                END;
                ID_DeletePage:BEGIN
                    KrPageMan.DeletePage;
                END;
                IDB_PAGECONF:BEGIN
                    St:=KrPageMan.GetCurCntr.AppName+#0;
                    PageConfData.hptrIcon:=WinLoadFileIcon(@st[1],FALSE);

                    IF PageConfData.hptrIcon=NullHandle THEN
                    BEGIN
                        PageConfData.hptrIcon:=WinLoadPointer( HWND_DESKTOP,
                                                               NULLHANDLE,
                                                               ICO_BLANK);
                    END;
                    PageConfData.AppName:=KrPageMan.GetCurCntr.AppName;
                    StrPCopy(PageConfData.pChPageName,
                             KrPageMan.GetCurCntr.GroupName);
                    StrPCopy(PageConfData.pChPageInfo,
                             KrPageMan.GetCurCntr.GroupInfoStr);
                    PageConfData.ColumAttr:=KrPageMan.GetCurCntr.ColumAttr;
                    IF WinDlgBox(HWND_DESKTOP,
                                 Window,
                                 PageConfDlgProc,
                                 NULLHANDLE,
                                 DLG_PAGECONFIG,
                                 @PageConfData)        =Ord(TRUE) THEN
                    BEGIN
                        CurPageID:=WinSendMsg(KrPageMan.hwndNB,
                                              BKM_QUERYPAGEID,
                                              CurPageID,
                                              MPFROM2SHORT(BKA_TOP,BKA_MAJOR));
                        WinSendMsg(KrPageMan.hwndNb,
                                   BKM_SETTABTEXT,
                                   CurPageID,
                                   LONG(PageConfData.pChPageName));
                        rc:=WinSendMsg(KrPageMan.hwndNb,
                                       BKM_SETSTATUSLINETEXT,
                                       CurPageID,
                                       LONG(PageConfData.pChPageInfo));
                        CurCntr:=KrPageMan.GetContainer(CurPageID);
                        CurCntr.GroupName:=StrPas(PageConfData.pChPageName);
                        CurCntr.GroupInfoStr:=StrPas(PageConfData.pChPageInfo);
                        CurCntr.AppName:=PageConfData.AppName;
                        CurCntr.ColumAttr:=PageConfData.ColumAttr;
                        CurCntr.FlushColum;
//                        CurCntr.ReInsertColum;
                        FOR i:=0 TO KrPageMan.ContainerList.Count-1 DO BEGIN
                            CurCntr:=ContainerClass(KrPageMan.ContainerList[i]);
                            IF CurCntr.id=CurPageID THEN BEGIN
                                KrPageMan.RenamePageMenu(i,CurCntr.GroupName);
                            END;
                        END;
                    END;
                END;
                IDB_CONFIG:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));
                    IF pRow=NIL THEN EXIT;

                    WITH pRow^ DO BEGIN
                        RecConfData.hptrIcon:=Core.hptrIcon;
                        FOR i:=1 TO MaxColumList DO BEGIN
                            IF pChAry[i]<>NIL THEN
                                StrCopy(RecConfData.pChAry[i],pChAry[i])
                            ELSE
                                StrCopy(RecConfData.pChAry[i],'');
                        END;
                        IF Core.pszIcon<>NIL THEN
                            StrCopy(RecConfData.pChAry[2],Core.pszIcon)
                        ELSE
                            StrCopy(RecConfData.pChAry[2],'');
                        RecConfData.isExpireCheck:=isExpireCheck;
                    END;
                    IF WinDlgBox(HWND_DESKTOP,
                                 Window,
                                 RecordConfDlgProc,
                                 NullHandle,
                                 DLG_RecordConfig,
                                 @RecConfData)=Ord(TRUE) THEN
                    BEGIN
                        IF pChToHPointer(RecConfData.pChAry[1],hptrIcon) THEN
                        BEGIN
                            IF isBlankpCh(RecConfData.pChAry[1]) THEN
                                pRow^.pChAry[1]:=AllocStrCopy(pRow^.pChAry[1],
                                                               BlankStr)
                            ELSE
                                pRow^.pChAry[1]:=AllocStrCopy(
                                                        pRow^.pChAry[1],
                                                        RecConfData.pChAry[1])
                        END;

                        pRow^.Core.hptrIcon:=hptrIcon;
                        IF pRow^.Core.pszIcon<>NIL THEN BEGIN
                            FreeMem(pRow^.Core.pszIcon,
                                    StrLen(pRow^.Core.pszIcon));
                            pRow^.Core.pszIcon:=NIL;
                        END;
                        pRow^.isExpireCheck:=RecConfData.isExpireCheck;
                        pRow^.Core.pszIcon:=AllocStrCopy(
                                                pRow^.Core.pszIcon,
                                                RecConfData.pChAry[2]);

                        FOR i:=3 TO MaxColumList DO BEGIN
                            IF i=8 THEN BEGIN
                                IF  (pRow^.pChAry[4]=NIL) OR
                                    (StrComp(pRow^.pChAry[4],
                                             RecConfData.pChAry[4])<>0)OR
                                NOT(isBlankpCh(RecConfData.pChAry[8])) THEN
                                BEGIN
                                    pRow^.pChAry[i]:=AllocStrPCopy(
                                                            pRow^.pChAry[i],
                                                            DateToStr(Now));
                                END;
                            END
                            ELSE BEGIN
                                IF isBlankpCh(RecConfData.pChAry[i]) THEN 
                                    pRow^.pChAry[i]:=AllocStrCopy(
                                                        pRow^.pChAry[i],
                                                        BlankStr)
                                    
                                ELSE
                                    pRow^.pChAry[i]:=AllocStrCopy(
                                                        pRow^.pChAry[i],
                                                        RecConfData.pChAry[i]);
                            END;
                        END;

                        WinSendMsg(CurCntr.GetHWnd,
                                   CM_INVALIDATERECORD,
                                   CMA_FIRST,
                                   MPFROM2SHORT(0,CMA_REPOSITION));
                    END;
                END;
                IDB_EXEC:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));
                    IF pRow=NIL THEN EXIT;
                    St:=StrPas(pRow^.pChAry[5]);
                    KrPageMan.RunExec(CurCntr.AppName,St);
                END;
                IDB_LOCK:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    IF CurCntr.DispState<>nodisp THEN
                        CurCntr.DispState:=SUCC(CurCntr.DispState)
                    ELSE
                        CurCntr.DispState:=Normal;
                    CurCntr.FlushColum;
//                    CurCntr.ReInsertColum;
                END;
                ID_NewRecord:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.InsertNewRecord;
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0);
                    IF KrPageMan.DataDoc.isDoc=FALSE THEN BEGIN
                        IF KrPageMan.DataDoc.isUseCrypt THEN
                            KrPageMan.SetDocName('new.crp')
                        ELSE
                            KrPageMan.SetDocName('new.xml');
                    END;
                END;
                ID_DeleteRecord:BEGIN
                    KrPageMan.GetCurCntr.DeleteRecord;
                END;
                ID_FilterExpire:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    CurCntr.isFilter:=NOT(CurCntr.isFilter);
                    ParamCommand.isFilter:=CurCntr.isFilter;
                    IF ParamCommand.isFilter THEN BEGIN
                        BkCol:=$00FFAAFF;
                        WinSetPresParam(CurCntr.GetHWnd,
                                        PP_BACKGROUNDCOLOR,
                                        4,
                                        @BkCol);
                    END
                    ELSE BEGIN
                        BkCol:=SYSCLR_WINDOWTEXT;
                        WinSetPresParam(CurCntr.GetHWnd,
                                        PP_BACKGROUNDCOLOR,
                                        4,
                                        @BkCol);
                    END;
                    WinSendMsg( CurCntr.GetHWnd,
                                CM_FILTER,
                                MPFROMP(@FilterExpire),
                                MPFROMP(@ParamCommand) );
                END;
                ID_CopyTo .. ID_CopyTo+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_CopyTo;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.CopyRecord(pRow);
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
                END;
                ID_MoveTo .. ID_MoveTo+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_MoveTo;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.MoveRecord(pRow);
                    KrPageMan.GetCurCntr.DeleteRecord;
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
                END;
                ID_SORTBYICON:BEGIN
                    i:=1;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_SORTBYDESC:BEGIN
                    i:=2;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_SORTBYUSER:BEGIN
                    i:=3;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_SORTBYURL:BEGIN
                    i:=5;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_SORTBYSN:BEGIN
                    i:=6;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_SORTBYUPDATE:BEGIN
                    i:=8;
                    WinSendMsg( KrPageMan.GetCurCntr.GetHWnd,
                                CM_SORTRECORD,
                                MPFROMP(@SortByColum),
                                MPFROMP(@i) );
                END;
                ID_COPYUSR:BEGIN
                    pRow:=
                      pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));
                    IF pRow<>NIL THEN
                        KrPageMan.CopyClip(pRow^.pChAry[3]);
                END;
                ID_COPYPASS:BEGIN
                    pRow:=
                      pRowInfo(WinSendMsg(KrPageMan.GetCurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));
                    IF pRow<>NIL THEN
                        KrPageMan.CopyClip(pRow^.pChAry[4]);END;
            END;
        END;
        WM_CLOSE:BEGIN
            KrPageMan.FlushSave;
            WinPostMsg(Window,WM_QUIT,0,0);
        END;
        ELSE BEGIN
            IF pWCtlData<>NIL THEN
                result:=pWCtlData^.pOldProc(Window, msg, mp1, mp2)
            ELSE
                result:=WinDefWindowProc(Window, msg, mp1, mp2);
        END;
    END;(**case msg**)
END;

FUNCTION ContainerClientProc(Window:HWnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
VAR
   pWCtlData:PWindowCellCtlData;
   pCnrEdit:pCNREDITDATA;
   pRI:pRowInfo;
   nCh:pChar;
   hwndCnr,hwndMLE:hwnd;
   AryIndex:INTEGER;
   newsize:INTEGER;
   DataOffset:ULong;
   pInfo:pCnrInfo;
   Info:CnrInfo;
   CurPageID:ULong;
   CurCntr:ContainerClass;
   pRow:pRowInfo;
   ptl:PointL;
   OldPassword:pChar;
   OldUpdate:pChar;
   st:string;
   i,k:INTEGER;
BEGIN
    pWCtlData:=PWindowCellCtlData(WinQueryWindowULong(Window,QWL_USER));
    result   :=0;
    CASE msg OF
        WM_CONTROL:BEGIN
            CASE SHORT2FROMMP(mp1) OF
                CN_ENDEDIT:BEGIN
                    pCnrEdit:=pCNREDITDATA(mp2);
                    IF pCnrEdit^.pFieldInfo<>NIL THEN
                        DataOffset:=pCnrEdit^.pFieldInfo^.Offstruct
                    ELSE
                        DataOffset:=SizeOf(RecordCore)-1;
                    IF DataOffset>SizeOf(RecordCore)+24 THEN EXIT;
                    NewSize:=pCnrEdit^.cbText+1;
                    pRI:=pRowInfo(pCnrEdit^.pRecord);
                    hwndCnr:=pCnrEdit^.hwndCnr;
                    hwndMLE:=WinWindowFromID(hwndCnr,CID_MLE);
                    AryIndex:=(DataOffset-SizeOF(RECORDCORE)) div 4 +1;
                    OldPassword:=NIL;
                    OldUpdate:=NIL;
                    OldPassword:=AllocStrCopy(OldPassword,pRI^.pChAry[4]);
                    OldUpdate:=AllocStrCopy(OldUpdate,pRI^.pChAry[8]);
                    IF NewSize<MaxCharLength THEN
                        NewSize:=MaxCharLength;
                    GetMem(nCh,NewSize);
                    WinQueryWindowText( hwndMLE, NewSize, nCh);
                    IF isBlankpCh(nCh) THEN 
                       nCh:=AllocStrCopy(nCh,BlankStr);
                    IF DataOffset<SizeOf(RECORDCORE) THEN BEGIN
                        FreeMem(pRI^.Core.pszIcon,
                                StrLen(pRI^.Core.pszIcon));
                        pRI^.Core.pszIcon:=nCh;
                    END
                    ELSE BEGIN
                        FreeMem(pRI^.pChAry[AryIndex],
                                StrLen(pRI^.pChAry[AryIndex]));
                        pRI^.pChAry[AryIndex]:=nCh;;
                    END;

                    IF (StrComp(pRI^.pChAry[4],OldPassword)<>0)
                    OR isBlankpCh(pRI^.pChAry[8]) THEN
                        pRI^.pChAry[8]:=AllocStrPCopy(pRI^.pChAry[8],
                                                      DateToStr(now));
                END;(**CN_ENDEDIT**)
                CN_CONTEXTMENU:BEGIN
                    CurPageID:=WinSendMsg(KrPageMan.hwndNB,
                                          BKM_QUERYPAGEID,
                                          CurPageID,
                                          MPFROM2SHORT(BKA_TOP,BKA_MAJOR));

                    pRow:=pRowInfo(mp2);
                    IF pRow=NIL THEN EXIT;
                    WinQueryPointerPos(HWND_DESKTOP,ptl);
                    WinMapWindowPoints(HWND_DESKTOP,Window,ptl,1);
                    KrPageMan.hwndConMenu:=WinLoadMenu(KrPageMan.FrameWindow,
                                                       NullHandle,
                                                       ID_CONTEXTMENU);

                    DeleteMenu(KrPageMan.hwndConMenu,ID_MoveRecord,MoveToIndex);
                    DeleteMenu(KrPageMan.hwndConMenu,ID_CopyRecord,CopyToIndex);

                    FOR i:=0 TO KrPageMan.ContainerList.Count-1 DO BEGIN
                        CurCntr:=ContainerClass(KrPageMan.ContainerList[i]);
                        St:=CurCntr.GroupName;
                        InsertSubMenu(KrPageMan.hwndConMenu,
                                      ID_CopyRecord,
                                      ID_ContextCopy+i,
                                      St);

                        InsertSubMenu(KrPageMan.hwndConMenu,
                                      ID_MoveRecord,
                                      ID_ContextMove+i,
                                      St);


                    END;

                    WinPopUpMenu(Window,
                                 Window,
                                 KrPageMan.hwndConMenu,
                                 ptl.x,
                                 ptl.y,
                                 ID_CONTEXTMENU,
                                 PU_HCONSTRAIN OR PU_VCONSTRAIN OR
                                 PU_KEYBOARD OR PU_MOUSEBUTTON1 OR
                                 PU_MOUSEBUTTON2 OR PU_NONE);
                    EXIT;
                END;
                CN_ENTER:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_ConfRecord,
                               0);
                END;
            END;(**case**)
        END;(**wm_control**)
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                ID_CONTEXTNEW:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_NewRecord,
                               0);
                END;
                ID_CONTEXTDEL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_DeleteRecord,
                               0);
                END;
                ID_CONTEXTCONF:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_ConfRecord,
                               0);
                END;
                ID_CONTEXTSORTBYICON:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                               WM_COMMAND,
                               ID_SORTBYICON,
                               0);
                END;
                ID_CONTEXTSORTBYDESC:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYDESC,
                                0);
                END;
                ID_CONTEXTSORTBYUSER:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYUSER,
                                0);
                END;
                ID_CONTEXTSORTBYURL:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYURL,
                                0);
                END;
                ID_CONTEXTSORTBYSN:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYSN,
                                0);
                END;
                ID_CONTEXTSORTBYUPDATE:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_SORTBYUPDATE,
                                0);
                END;
                ID_CONTEXTCOPYPASS:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYPASS,
                                0);
                END;
                ID_CONTEXTCOPYUSR:BEGIN
                    WinSendMsg(KrPageMan.FrameWindow,
                                WM_COMMAND,
                                ID_COPYUSR,
                                0);
                END;
                ID_ContextCopy .. ID_ContextCopy+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_ContextCopy;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.CopyRecord(pRow);
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
                END;
                ID_ContextMove .. ID_ContextMove+99:BEGIN
                    CurCntr:=KrPageMan.GetCurCntr;
                    pRow:=
                      pRowInfo(WinSendMsg(CurCntr.GetHWnd,
                                          CM_QueryRecordEmphasis,
                                          CMA_FIRST,
                                          MPFROMSHORT(CRA_SELECTED) ));

                    k:=SHORT1FROMMP(mp1)-ID_ContextMove;
                    CurCntr:=ContainerClass(KrPageMan.ContainerList[k]);
                    IF CurCntr.isColum =FALSE THEN
                        CurCntr.SetColum;
                    CurCntr.MoveRecord(pRow);
                    KrPageMan.GetCurCntr.DeleteRecord;
                    WinSendMsg(CurCntr.GetHWnd,CM_INVALIDATERECORD,0,0)
                END;

            END;
        END;(**WM_COMMAND**)
        ELSE BEGIN
            IF pWCtlData<>NIL THEN
                result:=pWCtlData^.pOldProc(Window, msg, mp1, mp2)
            ELSE
                result:=WinDefWindowProc(Window, msg, mp1, mp2);
        END;
    END;(**case msg**)
END;


VAR
    Anchor   :HAB;
    mq       :HMQ;
    msg      :QMSG;
    swp      :os2pmapi.SWP;
    hwndNB,hwndFrame:hwnd;
    Node:TDOMNode;
    cc:INTEGER;
    ArgSt:string;
BEGIN
    ArgSt:='';
    IF ParamCount>0 THEN ArgSt:=ParamStr(1);

    Anchor:=WinInitialize(0);
    IF Anchor=0 THEN HALT(-1);

    mq:=WinCreateMsgQueue(Anchor, 0);

    IF mq=0 THEN BEGIN
        WinTerminate(Anchor);
        HALT(-2);
    END;

    ToolkitInit(Anchor);

    WinQueryWindowPos(HWND_DESKTOP, swp);

    hwndFrame:=CreateCell(mainFrame, HWND_DESKTOP, 0);
    CreateToolbar(hwndFrame,mainTb);

    IF hwndFrame<>0 THEN BEGIN
        hwndNb:=CellWindowFromID(hwndFrame, ID_NOTEBOOK);
        KrPageMan:=KrPageManegerClass.Create(hwndNB);
        KrPageMan.SetAnchor(Anchor);
        KrPageMan.LoadMsg;
        KrPageMan.FrameWindow:=hwndFrame;
        KrPageMan.CreateBlankPage(nbClient);

        DeleteMenu(WinWindowFromID(hwndFrame,FID_MENU),
                    ID_MoveRecord,
                    MoveToIndex);
        DeleteMenu(WinWindowFromID(hwndFrame,FID_MENU),
                    ID_CopyRecord,
                    CopyToIndex);


        WinSetWindowPos(hwndFrame,
                        NULLHANDLE,
                        swp.x+swp.cx div 8,
                        swp.y+swp.cy div 8,
                        (swp.cx div 4)* 3,
                        (swp.cy div 4)*3,
                        SWP_ACTIVATE OR SWP_MOVE OR SWP_SIZE OR SWP_SHOW);
        PassConfData.isUse:=FALSE;
        IF (ArgSt='') OR (UpperCase(ExtractFileExt(ArgSt))='.CRP') THEN BEGIN
            WinDlgBox(HWND_DESKTOP,
                      hwndFrame,
                      PassConfDlgProc,
                      NullHandle,
                      DLG_PassConfig,
                      NIL);
            KrPageMan.DataDoc.isUseCrypt:=PassConfData.isUse;
            KrPageMan.DataDoc.password:=PassConfData.password;
        END;
        IF KrPageMan.DataDoc.isUseCrypt=FALSE THEN BEGIN
            ActiveMenu(hwndFrame,ID_FILEMENU,ID_FILEIMPORT,FALSE);
            ActiveMenu(hwndFrame,ID_FILEMENU,ID_FILEEXPORT,FALSE);
        END;
        IF (ArgSt<>'')AND (FileExists(ArgSt)) THEN
            KrPageMan.LoadData(ArgSt,nbClient);

        // -------------------------------
        WHILE WinGetMsg(Anchor,msg,0,0,0) DO WinDispatchMsg(Anchor,msg);
        // -------------------------------
    END;

    WinDestroyWindow(hwndFrame);
    WinDestroyMsgQueue(mq);
    WinTerminate(Anchor);
END.

